










#ifndef TICKY_H
#define TICKY_H


















#define TICKY_FIXED_HDR			(TICKY_HDR_SIZE)
#define TICKY_HDR_POSN			AFTER_PROF_HDR
#define AFTER_TICKY_HDR			(TICKY_FIXED_HDR+TICKY_HDR_POSN)



#ifndef TICKY_TICKY

#define TICKY_HDR_SIZE 		0
#define TICKY_HDR(closure)
#define SET_TICKY_HDR(closure,to)
#define	SET_STATIC_TICKY_HDR()

#else

#define TICKY_HDR_SIZE 		1
#define TICKY_HDR(closure) 	(((P_)(closure))[TICKY_HDR_POSN])
#define SET_TICKY_HDR(closure,to) TICKY_HDR(closure) = (to)
#define	SET_STATIC_TICKY_HDR()	,0

#endif /* TICKY_TICKY */

















#ifndef TICKY_TICKY

#define UPDATED_SET_UPDATED(n)	 /* nothing */
#define ENTERED_CHECK_UPDATED(n) /* nothing */

#else

#define UPDATED_SET_UPDATED(n)	do { TICKY_HDR(n) = 1; } while(0)

#define ENT_UPD_HISTO(n) 					\
	do { I_ __idx;						\
	  __idx = (n) - 1;					\
								\
	  /* once 9th enter is recorded, we do not tick anymore;*/\
	  /* we want "TotUpdates - <all 9 cols>" to equal */	\
	  /* "updates that were never entered" */		\
	  if ( __idx <= 8 )					\
	     UPD_ENTERED_hst[__idx] += 1;			\
								\
	  /* now undo tick in previous histo slot ... */	\
	  if ( __idx >= 1 && __idx <= 8 )			\
	     UPD_ENTERED_hst[(__idx - 1)] -= 1;			\
	} while(0)

#define ENTERED_CHECK_UPDATED(n)  				\
	do {							\
	I_ t_hdr = TICKY_HDR(n);				\
								\
	if (t_hdr != 0 && AllFlags.doUpdEntryCounts) {		\
	    ENT_UPD_HISTO(t_hdr);				\
	    TICKY_HDR(n) += 1;					\
	}} while(0)

#endif /* TICKY_TICKY */









#ifdef TICKY_TICKY



































#define ALLOC_HEAP(n)	ALLOC_HEAP_ctr++; ALLOC_HEAP_tot += (n)





#define UN_ALLOC_HEAP(n) ALLOC_HEAP_ctr--; ALLOC_HEAP_tot -= (n)






#ifndef CONCURRENT
#define DO_ASTK_HWM()	if (SpA < max_SpA) { max_SpA = SpA; }
#define DO_BSTK_HWM()	if (SpB > max_SpB) { max_SpB = SpB; }
#else
/* 
 * This is not direction sensitive, because we threads people are well-behaved.
 * However, it might be a good idea to cache the constant bits (DEP + BOT and
 * HWM) from the STKO and TSO in more readily accessible places. -- ToDo!
 */
#define DO_ASTK_HWM() {		    \
  I_ depth = STKO_ADEP(StkOReg) + AREL((I_) STKO_ASTK_BOT(StkOReg) - (I_) SpA);\
  if (depth > TSO_AHWM(CurrentTSO)) \
    TSO_AHWM(CurrentTSO) = depth;   \
}
#define DO_BSTK_HWM() {		    \
  I_ depth = STKO_BDEP(StkOReg) + BREL((I_) STKO_BSTK_BOT(StkOReg) - (I_) SpB);\
  if (depth > TSO_BHWM(CurrentTSO)) \
    TSO_BHWM(CurrentTSO) = depth;   \
}
#endif





#define A_STK_STUB(n)	A_STK_STUB_ctr += (n)
#define A_STK_REUSE(n)	A_STK_REUSE_ctr += (n) /* not used at all? */
#define B_STK_REUSE(n)	B_STK_REUSE_ctr += (n) /* not used at all? */



















#define ALLOC_FUN(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_FUN_ctr++;	ALLOC_FUN_adm += (a); \
			 ALLOC_FUN_gds += (g);	ALLOC_FUN_slp += (s); \
			 ALLOC_HISTO(FUN,a,g,s)
#define ALLOC_THK(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_THK_ctr++;	ALLOC_THK_adm += (a); \
			 ALLOC_THK_gds += (g);	ALLOC_THK_slp += (s); \
			 ALLOC_HISTO(THK,a,g,s)
#define ALLOC_CON(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_CON_ctr++;	ALLOC_CON_adm += (a); \
			 ALLOC_CON_gds += (g);	ALLOC_CON_slp += (s); \
			 ALLOC_HISTO(CON,a,g,s)
#define ALLOC_TUP(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_TUP_ctr++;	ALLOC_TUP_adm += (a); \
			 ALLOC_TUP_gds += (g);	ALLOC_TUP_slp += (s); \
			 ALLOC_HISTO(TUP,a,g,s)
#define ALLOC_BH(a,g,s,t)  ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_BH_ctr++;	ALLOC_BH_adm += (a); \
			 ALLOC_BH_gds += (g);	ALLOC_BH_slp += (s); \
			 ALLOC_HISTO(BH,a,g,s)
#if 0
#define ALLOC_PAP(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_PAP_ctr++;	ALLOC_PAP_adm += (a); \
			 ALLOC_PAP_gds += (g);	ALLOC_PAP_slp += (s); \
			 ALLOC_HISTO(PAP,a,g,s)
#endif






#define ALLOC_UPD_PAP(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_UPD_PAP_ctr++;  ALLOC_UPD_PAP_adm += (a); \
			 ALLOC_UPD_PAP_gds += (g); ALLOC_UPD_PAP_slp += (s); \
			 ALLOC_HISTO(UPD_PAP,a,g,s)
#if 0
#define ALLOC_UPD_CON(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			 ALLOC_UPD_CON_ctr++;  ALLOC_UPD_CON_adm += (a); \
			 ALLOC_UPD_CON_gds += (g); ALLOC_UPD_CON_slp += (s); \
			 ALLOC_HISTO(UPD_CON,a,g,s)
#endif /* 0 */







#define ALLOC_STK(a,g,s) ALLOC_STK_ctr++;	ALLOC_STK_adm += (a); \
			 ALLOC_STK_gds += (g);	ALLOC_STK_slp += (s); \
			 ALLOC_HISTO(STK,a,g,s)

#define ALLOC_TSO(a,g,s) ALLOC_TSO_ctr++;	ALLOC_TSO_adm += (a); \
			 ALLOC_TSO_gds += (g);	ALLOC_TSO_slp += (s); \
			 ALLOC_HISTO(TSO,a,g,s)

#define ALLOC_FMBQ(a,g,s) ALLOC_FMBQ_ctr++;	ALLOC_FMBQ_adm += (a); \
			 ALLOC_FMBQ_gds += (g);	ALLOC_FMBQ_slp += (s); \
			 ALLOC_HISTO(FMBQ,a,g,s)

#define ALLOC_FME(a,g,s) ALLOC_FME_ctr++;	ALLOC_FME_adm += (a); \
			 ALLOC_FME_gds += (g);	ALLOC_FME_slp += (s); \
			 ALLOC_HISTO(FME,a,g,s)

#define ALLOC_BF(a,g,s)  ALLOC_BF_ctr++;	ALLOC_BF_adm += (a); \
			 ALLOC_BF_gds += (g);	ALLOC_BF_slp += (s); \
			 ALLOC_HISTO(BF,a,g,s)








#define ALLOC_HISTO(categ,a,g,s) \
	{ I_ __idx;						 \
	  __idx = (a) + (g) + (s) - 2;				 \
	 CAT3(ALLOC_,categ,_hst)[((__idx > 4) ? 4 : __idx)] += 1;} 








#define ALLOC_PRIM(a,g,s,t) ASSERT((t) == (a)+(g)+(s)); \
			  ALLOC_PRIM_ctr++;	 ALLOC_PRIM_adm += (a); \
			  ALLOC_PRIM_gds += (g); ALLOC_PRIM_slp += (s); \
			  ALLOC_HISTO(PRIM,a,g,s)
#define ALLOC_PRIM2(w) ALLOC_PRIM_ctr++; ALLOC_PRIM_gds +=(w); \
		       ALLOC_HISTO(PRIM,0,w,0)









#define ENT_VIA_NODE()	ENT_VIA_NODE_ctr++	/* via ENT_ macro */

#define ENT_THK()	ENT_THK_ctr++
#define ENT_FUN_STD()	ENT_FUN_STD_ctr++	/* manifest fun; std entry pt */

#define ENT_CON(n)	ENTERED_CHECK_UPDATED(n); ENT_CON_ctr++	 /* enter code for constructor */
#define ENT_IND(n)	ENTERED_CHECK_UPDATED(n); ENT_IND_ctr++	 /* enter indirection */
#define ENT_PAP(n)	ENTERED_CHECK_UPDATED(n); ENT_PAP_ctr++	 /* enter partial application */






struct ent_counter {
    unsigned	registeredp:16,	/* 0 == no, 1 == yes */
    		arity:16,	/* arity (static info) */
    		Astk_args:16,	/* # of args off A stack */
    		Bstk_args:16;	/* # of args off B stack */
				/* (rest of args are in registers) */
    StgChar	*f_str;		/* name of the thing */
    StgChar	*f_arg_kinds;	/* info about the args types */
    StgChar	*wrap_str;	/* name of its wrapper (if any) */
    StgChar	*wrap_arg_kinds;/* info about the orig wrapper's arg types */
    I_		ctr;		/* the actual counter */
    struct ent_counter *link;	/* link to chain them all together */
};

/* OLD: extern void RegisterEntryPt PROTO((struct ent_counter *)); */
extern struct ent_counter *ListOfEntryCtrs;

#define ENT_FUN_DIRECT(f_ct,f_str,f_arity,Aargs,Bargs,arg_kinds,wrap,wrap_kinds) \
	{							\
	static struct ent_counter f_ct				\
	  = { 0,						\
	      (f_arity), (Aargs), (Bargs), (f_str), (arg_kinds),\
	      (wrap), (wrap_kinds),				\
	      0, NULL };					\
	if ( ! f_ct.registeredp ) {				\
	    /* hook this one onto the front of the list */	\
	    f_ct.link = ListOfEntryCtrs;			\
	    ListOfEntryCtrs = & (f_ct);				\
								\
	    /* mark it as "registered" */			\
	    f_ct.registeredp = 1;				\
	}							\
	f_ct.ctr += 1;						\
	}							\
	ENT_FUN_DIRECT_ctr++ /* the old boring one */






































#define RET_HISTO(categ,n,offset) \
	{ I_ __idx;						 \
	  __idx = (n) - (offset);				 \
	 CAT3(RET_,categ,_hst)[((__idx > 8) ? 8 : __idx)] += 1;} 

/* "slide" histogramming by (__STG_REGS_AVAIL__ - 1) -- usually 7 --
   so we do not collect lots and lots of useless zeros for _IN_HEAP.
   WDP 95/11
*/
#define RET_NEW_IN_HEAP(n)	RET_NEW_IN_HEAP_ctr++;	    \
				RET_HISTO(NEW_IN_HEAP,n,__STG_REGS_AVAIL__ - 1)
#define RET_OLD_IN_HEAP(n)	RET_OLD_IN_HEAP_ctr++;	    \
				RET_HISTO(OLD_IN_HEAP,n,__STG_REGS_AVAIL__ - 1)
#define RET_SEMI_IN_HEAP(n)	RET_SEMI_IN_HEAP_ctr++;	    \
				RET_HISTO(SEMI_IN_HEAP,n,__STG_REGS_AVAIL__ - 1)

#define RET_NEW_IN_REGS(n)	RET_NEW_IN_REGS_ctr++;	    \
				ReturnInRegsNodeValid = 0;  \
				RET_HISTO(NEW_IN_REGS,n,0)
#define RET_OLD_IN_REGS(n)	RET_OLD_IN_REGS_ctr++;	    \
				ReturnInRegsNodeValid = 1;  \
				RET_HISTO(OLD_IN_REGS,n,0)
#define RET_SEMI_IN_REGS(n,u)	RET_SEMI_IN_REGS_ctr++;	    \
				RET_SEMI_loads_avoided += ((n) - (u)); \
				RET_HISTO(SEMI_IN_REGS,u,0)

#define RET_SEMI_BY_DEFAULT()/*???*/	RET_SEMI_BY_DEFAULT_ctr++

#define RET_SEMI_FAILED(tag)	do {					\
				if ((tag) == INFO_IND_TAG)		\
				    RET_SEMI_FAILED_IND_ctr++;		\
				else					\
				    RET_SEMI_FAILED_UNEVAL_ctr++;	\
				} while (0)






#define VEC_RETURN(n)		VEC_RETURN_ctr++;	    \
				RET_HISTO(VEC_RETURN,n,0)

























#define UPDF_OMITTED()		UPDF_OMITTED_ctr++

#define UPDF_STD_PUSHED()	UPDF_STD_PUSHED_ctr++
#define UPDF_CON_PUSHED()	UPDF_CON_PUSHED_ctr++
#define UPDF_HOLE_PUSHED()	UPDF_HOLE_PUSHED_ctr++

#define UPDF_RCC_PUSHED()	UPDF_RCC_PUSHED_ctr++
#define UPDF_RCC_OMITTED()	UPDF_RCC_OMITTED_ctr++





























#define UPD_HISTO(categ,n) \
	{ I_ __idx;						 \
	  __idx = (n);						 \
	 CAT3(UPD_,categ,_hst)[((__idx > 8) ? 8 : __idx)] += 1;} 

#define UPD_EXISTING()		UPD_EXISTING_ctr++
#define UPD_SQUEEZED()		UPD_SQUEEZED_ctr++

#define UPD_CON_W_NODE()	UPD_CON_W_NODE_ctr++

#define UPD_CON_IN_NEW(n)	UPD_CON_IN_NEW_ctr++ ; \
				UPD_HISTO(CON_IN_NEW,n)
#define UPD_PAP_IN_NEW(n)	UPD_PAP_IN_NEW_ctr++ ; \
				UPD_HISTO(PAP_IN_NEW,n)
/* ToDo: UPD_NEW_COPY_ctr, as below */

#define UPD_CON_IN_PLACE(n)	UPD_CON_IN_PLACE_ctr++ ; \
				UPD_IN_PLACE_COPY_ctr += ReturnInRegsNodeValid ; \
				/* increments if True; otherwise, no */ \
				UPD_HISTO(CON_IN_PLACE,n)
#define UPD_PAP_IN_PLACE()	UPD_PAP_IN_PLACE_ctr++ ; \
				UPD_IN_PLACE_COPY_ctr += ReturnInRegsNodeValid
				/* increments if True; otherwise, no */




#define UPD_NEW_IND()			UPD_NEW_IND_ctr++;
#define UPD_NEW_IN_PLACE_PTRS()		UPD_NEW_IN_PLACE_PTRS_ctr++;
#define UPD_NEW_IN_PLACE_NOPTRS()	UPD_NEW_IN_PLACE_NOPTRS_ctr++;
#define UPD_OLD_IND()			UPD_OLD_IND_ctr++;			
#define UPD_OLD_IN_PLACE_PTRS()		UPD_OLD_IN_PLACE_PTRS_ctr++;
#define UPD_OLD_IN_PLACE_NOPTRS()	UPD_OLD_IN_PLACE_NOPTRS_ctr++;













#define GC_SEL_ABANDONED()		GC_SEL_ABANDONED_ctr++;
#define GC_SEL_MINOR()			GC_SEL_MINOR_ctr++;
#define GC_SEL_MAJOR()			GC_SEL_MAJOR_ctr++;

#define GC_SHORT_IND()			GC_SHORT_IND_ctr++;
#define GC_SHORT_CAF()			GC_SHORT_CAF_ctr++;
#define GC_COMMON_CHARLIKE()		GC_COMMON_CHARLIKE_ctr++;
#define GC_COMMON_INTLIKE()		GC_COMMON_INTLIKE_ctr++;
#define GC_COMMON_INTLIKE_FAIL()	GC_COMMON_INTLIKE_FAIL_ctr++;
#define GC_COMMON_CONST()		GC_COMMON_CONST_ctr++;









extern I_ ALLOC_HEAP_ctr;
extern I_ ALLOC_HEAP_tot;

extern PP_ max_SpA;
extern P_  max_SpB;

extern I_ A_STK_STUB_ctr;
/* not used at all?
extern I_ A_STK_REUSE_ctr;
extern I_ B_STK_REUSE_ctr;
*/

extern I_ ALLOC_FUN_ctr;
extern I_ ALLOC_FUN_adm;
extern I_ ALLOC_FUN_gds;
extern I_ ALLOC_FUN_slp;
extern I_ ALLOC_FUN_hst[5];
extern I_ ALLOC_THK_ctr;
extern I_ ALLOC_THK_adm;
extern I_ ALLOC_THK_gds;
extern I_ ALLOC_THK_slp;
extern I_ ALLOC_THK_hst[5];
extern I_ ALLOC_CON_ctr;
extern I_ ALLOC_CON_adm;
extern I_ ALLOC_CON_gds;
extern I_ ALLOC_CON_slp;
extern I_ ALLOC_CON_hst[5];
extern I_ ALLOC_TUP_ctr;
extern I_ ALLOC_TUP_adm;
extern I_ ALLOC_TUP_gds;
extern I_ ALLOC_TUP_slp;
extern I_ ALLOC_TUP_hst[5];
extern I_ ALLOC_BH_ctr;
extern I_ ALLOC_BH_adm;
extern I_ ALLOC_BH_gds;
extern I_ ALLOC_BH_slp;
extern I_ ALLOC_BH_hst[5];
/*
extern I_ ALLOC_PAP_ctr;
extern I_ ALLOC_PAP_adm;
extern I_ ALLOC_PAP_gds;
extern I_ ALLOC_PAP_slp;
extern I_ ALLOC_PAP_hst[5];
*/
/*
extern I_ ALLOC_UPD_CON_ctr;
extern I_ ALLOC_UPD_CON_adm;
extern I_ ALLOC_UPD_CON_gds;
extern I_ ALLOC_UPD_CON_slp;
extern I_ ALLOC_UPD_CON_hst[5];
*/
extern I_ ALLOC_UPD_PAP_ctr;
extern I_ ALLOC_UPD_PAP_adm;
extern I_ ALLOC_UPD_PAP_gds;
extern I_ ALLOC_UPD_PAP_slp;
extern I_ ALLOC_UPD_PAP_hst[5];
extern I_ ALLOC_PRIM_ctr;
extern I_ ALLOC_PRIM_adm;
extern I_ ALLOC_PRIM_gds;
extern I_ ALLOC_PRIM_slp;
extern I_ ALLOC_PRIM_hst[5];

#ifdef CONCURRENT
extern I_ ALLOC_STK_ctr;
extern I_ ALLOC_STK_adm;
extern I_ ALLOC_STK_gds;
extern I_ ALLOC_STK_slp;
extern I_ ALLOC_STK_hst[5];
extern I_ ALLOC_TSO_ctr;
extern I_ ALLOC_TSO_adm;
extern I_ ALLOC_TSO_gds;
extern I_ ALLOC_TSO_slp;
extern I_ ALLOC_TSO_hst[5];
#ifdef PAR
extern I_ ALLOC_FMBQ_ctr;
extern I_ ALLOC_FMBQ_adm;
extern I_ ALLOC_FMBQ_gds;
extern I_ ALLOC_FMBQ_slp;
extern I_ ALLOC_FMBQ_hst[5];
extern I_ ALLOC_FME_ctr;
extern I_ ALLOC_FME_adm;
extern I_ ALLOC_FME_gds;
extern I_ ALLOC_FME_slp;
extern I_ ALLOC_FME_hst[5];
extern I_ ALLOC_BF_ctr;
extern I_ ALLOC_BF_adm;
extern I_ ALLOC_BF_gds;
extern I_ ALLOC_BF_slp;
extern I_ ALLOC_BF_hst[5];
#endif
#endif

extern I_ ENT_VIA_NODE_ctr;

extern I_ ENT_CON_ctr;
extern I_ ENT_FUN_STD_ctr;
extern I_ ENT_FUN_DIRECT_ctr;
extern I_ ENT_IND_ctr;
extern I_ ENT_PAP_ctr;
extern I_ ENT_THK_ctr;

extern I_ UPD_ENTERED_hst[9];

extern I_ RET_NEW_IN_HEAP_ctr;
extern I_ RET_NEW_IN_REGS_ctr;
extern I_ RET_OLD_IN_HEAP_ctr;
extern I_ RET_OLD_IN_REGS_ctr;
extern I_ RET_SEMI_BY_DEFAULT_ctr;
extern I_ RET_SEMI_IN_HEAP_ctr;
extern I_ RET_SEMI_IN_REGS_ctr;
extern I_ VEC_RETURN_ctr;

extern I_ RET_SEMI_FAILED_IND_ctr;
extern I_ RET_SEMI_FAILED_UNEVAL_ctr;

extern I_ RET_SEMI_loads_avoided;

extern I_ RET_NEW_IN_HEAP_hst[9];
extern I_ RET_NEW_IN_REGS_hst[9];
extern I_ RET_OLD_IN_HEAP_hst[9];
extern I_ RET_OLD_IN_REGS_hst[9];
/*no such thing: extern I_ RET_SEMI_BY_DEFAULT_hst[9]; */
extern I_ RET_SEMI_IN_HEAP_hst[9];
extern I_ RET_SEMI_IN_REGS_hst[9];
extern I_ RET_VEC_RETURN_hst[9];

extern I_ ReturnInRegsNodeValid; /* see below */

extern I_ UPDF_OMITTED_ctr;
extern I_ UPDF_STD_PUSHED_ctr;
extern I_ UPDF_CON_PUSHED_ctr;
extern I_ UPDF_HOLE_PUSHED_ctr;

extern I_ UPDF_RCC_PUSHED_ctr;
extern I_ UPDF_RCC_OMITTED_ctr;

extern I_ UPD_EXISTING_ctr;
extern I_ UPD_SQUEEZED_ctr;
extern I_ UPD_CON_W_NODE_ctr;
extern I_ UPD_CON_IN_PLACE_ctr;
extern I_ UPD_PAP_IN_PLACE_ctr;
extern I_ UPD_CON_IN_NEW_ctr;
extern I_ UPD_PAP_IN_NEW_ctr;

extern I_ UPD_CON_IN_PLACE_hst[9];
extern I_ UPD_CON_IN_NEW_hst[9];
extern I_ UPD_PAP_IN_NEW_hst[9];

extern I_ UPD_NEW_IND_ctr;
extern I_ UPD_NEW_IN_PLACE_PTRS_ctr;
extern I_ UPD_NEW_IN_PLACE_NOPTRS_ctr;
extern I_ UPD_OLD_IND_ctr;
extern I_ UPD_OLD_IN_PLACE_PTRS_ctr;
extern I_ UPD_OLD_IN_PLACE_NOPTRS_ctr;

extern I_ UPD_IN_PLACE_COPY_ctr; /* see below */

extern I_ GC_SEL_ABANDONED_ctr;
extern I_ GC_SEL_MINOR_ctr;
extern I_ GC_SEL_MAJOR_ctr;
extern I_ GC_SHORT_IND_ctr;
extern I_ GC_SHORT_CAF_ctr;
extern I_ GC_COMMON_CHARLIKE_ctr;
extern I_ GC_COMMON_INTLIKE_ctr;
extern I_ GC_COMMON_INTLIKE_FAIL_ctr;
extern I_ GC_COMMON_CONST_ctr;

#endif /* TICKY_TICKY */









#ifndef TICKY_TICKY

#define ALLOC_HEAP(n)	 /* nothing */
#define UN_ALLOC_HEAP(n) /* nothing */
#define DO_ASTK_HWM()	 /* nothing */
#define DO_BSTK_HWM()	 /* nothing */

#define A_STK_STUB(n)	/* nothing */
#define A_STK_REUSE(n)	/* not used at all */
#define B_STK_REUSE(n)	/* not used at all */

#define ALLOC_FUN(a,g,s,t) /* nothing */
#define ALLOC_THK(a,g,s,t) /* nothing */
#define ALLOC_CON(a,g,s,t) /* nothing */
#define ALLOC_TUP(a,g,s,t) /* nothing */
#define ALLOC_BH(a,g,s,t)  /* nothing */
/*#define ALLOC_PAP(a,g,s,t) /? nothing */
#define ALLOC_PRIM(a,g,s,t) /* nothing */
#define ALLOC_PRIM2(w)   /* nothing */
#define ALLOC_UPD_PAP(a,g,s,t) /* nothing */
/*#define ALLOC_UPD_CON(a,g,s,t) /? nothing */
#define ALLOC_STK(a,g,s) /* nothing */
#define ALLOC_TSO(a,g,s) /* nothing */
#define ALLOC_FMBQ(a,g,s) /* nothing */
#define ALLOC_FME(a,g,s) /* nothing */
#define ALLOC_BF(a,g,s) /* nothing */

#define ENT_VIA_NODE()	/* nothing */
#define ENT_THK()	/* nothing */
#define ENT_FUN_STD()	/* nothing */
#define ENT_FUN_DIRECT(f,f_str,f_arity,Aargs,Bargs,arg_kinds,wrap,wrap_kinds) \
			/* nothing */ 
#define ENT_CON(n)	/* nothing */
#define ENT_IND(n)	/* nothing */
#define ENT_PAP(n)	/* nothing */

#define RET_NEW_IN_HEAP(n)	/* nothing */
#define RET_NEW_IN_REGS(n)	/* nothing */
#define RET_OLD_IN_HEAP(n)	/* nothing */
#define RET_OLD_IN_REGS(n)	/* nothing */
#define RET_SEMI_BY_DEFAULT()	/* nothing */
#define RET_SEMI_IN_HEAP(n)	/* nothing */
#define RET_SEMI_IN_REGS(n,u)	/* nothing */
#define RET_SEMI_FAILED(t)	/* nothing */
#define VEC_RETURN(n)		/* nothing */

#define UPDF_OMITTED()		/* nothing */
#define UPDF_STD_PUSHED()	/* nothing */
#define UPDF_CON_PUSHED()	/* nothing */
#define UPDF_HOLE_PUSHED()	/* nothing */

#define UPDF_RCC_PUSHED()	/* nothing */
#define UPDF_RCC_OMITTED()	/* nothing */

#define UPD_EXISTING()		/* nothing */
#define UPD_SQUEEZED()		/* nothing */
#define UPD_CON_W_NODE()	/* nothing */
#define UPD_CON_IN_PLACE(n)	/* nothing */
#define UPD_PAP_IN_PLACE()	/* nothing */
#define UPD_CON_IN_NEW(n)	/* nothing */
#define UPD_PAP_IN_NEW(n)	/* nothing */

#define GC_SEL_ABANDONED()	/* nothing */
#define GC_SEL_MINOR()		/* nothing */
#define GC_SEL_MAJOR()		/* nothing */

#define GC_SHORT_IND()		/* nothing */
#define GC_SHORT_CAF()		/* nothing */
#define GC_COMMON_CHARLIKE()	/* nothing */
#define GC_COMMON_INTLIKE()	/* nothing */
#define GC_COMMON_INTLIKE_FAIL()/* nothing */
#define GC_COMMON_CONST()	/* nothing */




#define UPD_NEW_IND()			/* nothing */
#define UPD_NEW_IN_PLACE_PTRS()		/* nothing */
#define UPD_NEW_IN_PLACE_NOPTRS()	/* nothing */
#define UPD_OLD_IND()			/* nothing */
#define UPD_OLD_IN_PLACE_PTRS()		/* nothing */
#define UPD_OLD_IN_PLACE_NOPTRS()	/* nothing */

#endif /* <none-of-the-above> */




#endif /* ! TICKY_H */

